#include<bits/stdc++.h>
using namespace std;
int main()
{
    ifstream fi("sortmt.inp");
    ofstream fo("sortmt.out");
    int64_t m,n;
    fi>>m>>n;
    int64_t a[m*n+1];
    int64_t b[m*n+1];
    for(int64_t i=1;i<=m*n;i++)
    {
        fi>>a[i];
        b[i]=a[i];
    }
    sort(a+1,a+m*n+1);
    int64_t k=1;
    fo<<a[n*m]<<' '<<a[1]<<'\n';
    for(int64_t i=1;i<=m;i++)
    {
        sort(b+k,b+k+n);
        for(int64_t j=k;j<k+n;j++)
        {
            fo<<b[j]<<' ';
        }
        fo<<'\n';
        k+=n;
    }
}
